type t;

[@bs.get] external provider: t => ReasonReact.reactClass = "Provider";
[@bs.get] external consumer: t => ReasonReact.reactClass = "Consumer";

module type Config = {
  type t;
  let defaultValue: t;
};

module MakeContext = (Config: Config) => {
  [@bs.module "react"] external createContext: Config.t => t = "";

  let ctx = createContext(Config.defaultValue);

  module Provider = {
    let make = (~value: Config.t, children) =>
      ReasonReact.wrapJsForReason(
        ~reactClass=provider(ctx),
        ~props={"value": value},
        children,
      );
  };

  module Consumer = {
    let make = (children: array(Config.t => ReasonReact.reactElement)) =>
      ReasonReact.wrapJsForReason(
        ~reactClass=consumer(ctx),
        ~props=Js.Obj.empty(),
        children,
      );
  };
};
